<?php

namespace Drupal\mcapi_bursers;

use Drupal\mcapi\Entity\Storage\WalletStorage;
use Drupal\user\Entity\User;
use Drupal\user\UserInterface;
use Drupal\user\EntityOwnerInterface;
use Drupal\Core\Entity\ContentEntityInterface;

/**
 * Storage controller for wallet entity.
 */
class BurserWalletStorage extends WalletStorage {

  /**
   * {@inheritdoc}
   */
  public static function walletsOf(ContentEntityInterface $entity, $load = FALSE) {
    // If the entity is not a user, get the owner of the entity.
    if (!$entity instanceof UserInterface) {
      if ($entity instanceOf EntityOwnerInterface) {
        $entity = User::load($entity->getOwnerId());
      }
      else {
        trigger_error('Entity type '.$entity->getEntityTypeId().' cannot have wallets', E_USER_ERROR);
      }
    }
    $burser_of = \Drupal::entityQuery('mcapi_wallet')
      ->condition('bursers', $entity->id())
      ->execute();
    return array_unique(array_merge(parent::walletsOf($entity), $burser_of));
  }

}

