<?php

namespace Drupal\mcapi_cc\Plugin\migrate\source;

use Drupal\migrate_drupal\Plugin\migrate\source\DrupalSqlBase;

/**
 * Get the intertrading wallet id and the name of the user
 *
 * @MigrateSource(
 *   id = "d7_mcapi_cc_wallet",
 *   source_module = "mcapi_cc"
 * )
 */
class IntertradingWallet extends DrupalSqlBase {

  /**
   * {@inheritdoc}
   */
  public function query() {
    return $this->getDatabase()
      ->select('users', 'u')
      ->fields('u', ['name'])
      ->condition('uid', $this->variableGet('mcapi_cc_intertrading_account', 1));
  }

  public function fields(): array {
    return [
      'name' => $this->t('Account name'),
    ];
  }

  public function getIds(): array {
    $ids['name']['type'] = 'string';
    return $ids;
  }

}
