<?php

namespace Drupal\mcapi_forms\Plugin\Derivative;

use \Drupal\Core\Extension\ModuleHandler;
use Drupal\Core\Plugin\Discovery\ContainerDeriverInterface;
use Drupal\Component\Plugin\Derivative\DeriverBase;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Local action definitions to create a wallet for each entity types configured.
 */
class NewTransactionForm extends DeriverBase implements ContainerDeriverInterface {

  /**
   * @var ModuleHandler
   */
  protected $module_handler;

  /**
   * {@inheritdoc}
   */
  public function __construct(ModuleHandler $module_handler) {
    $this->moduleHandler = $module_handler;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, $base_plugin_id) {
    return new static(
      $container->get('module_handler')
    );
  }

  /**
   * {@inheritdoc}
   */
  public function getDerivativeDefinitions($base_plugin_definition) {
    // Add wallet links can go in three locations.
    if ($this->moduleHandler->moduleExists('field_ui')) {
      $this->derivatives['entity.mcapi_transaction.add_display_form'] = [
        'title' => 'Design new form',
        'route_name' => 'entity.entity_form_mode.add_form',
        'route_parameters' => [
          'entity_type_id' => 'mcapi_transaction'
        ],
        'appears_on' => [
          'mcapi.admin.transaction_form.list',
          'entity.entity_form_display.mcapi_transaction.default',
          'entity.entity_form_display.mcapi_transaction.form_mode'
        ],
        'weight' => 1,
      ];
    }
    return $this->derivatives;
  }

}
