<?php

namespace Drupal\mcapi_limits\Plugin\Block;

use Drupal\mcapi\Entity\Currency;
use Drupal\mcapi\Plugin\Block\WalletContextBlockBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a user balances block.
 *
 * @Block(
 *   id = "mcapi_limits",
 *   admin_label = @Translation("Balance limits"),
 *   category = @Translation("Community Accounting")
 * )
 * @todo inject moduleHandler
 */
class BalanceLimits extends WalletContextBlockBase {

  /**
   * {@inheritdoc}
   */
  public function blockForm($form, FormStateInterface $form_state) {
    $form = parent::blockForm($form, $form_state);
    // Only show currencies which have a plugin configured.
    if (isset($form['curr_ids'])) {
      foreach ($form['curr_ids']['#options'] as $curr_id => $currname) {
        if (Currency::load($curr_id)->getThirdPartySetting('mcapi_limits', 'plugin', 'none') == 'none') {
          unset($form['curr_ids']['#options'][$curr_id]);
        }
      }
    }
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function build() {
    \Drupal::moduleHandler()->loadInclude('mcapi_limits', 'inc');
    foreach ($this->getWallets() as $w) {
      $renderable['w'.$w->id()] = mcapi_view_limits($w, $this->configuration['curr_ids']);
    }
  }

}
