<?php

namespace Drupal\mcapi\Entity\Query;

use Drupal\Core\Entity\Query\Sql\Query as BaseQuery;
use Drupal\mcapi\Mcapi;

/**
 * Add access control to the wallet query according to the status of the wallet holder.
 * @todo make this work for every type of holder entity based on status of the OwnerEntity.
 */
class WalletQuery extends BaseQuery {

  /**
   * {@inheritdoc}
   *
   * Return only wallets whose owners are active.
   * This only kicks in when ONLY users are allowed to hold wallets at the moment.
   *
   * @todo Make this work with node and group wallet holders holders at the same time.
   */
  public function prepare(){
    parent::prepare();
    if ($this->accessCheck() and Mcapi::usersOnly()) {
      $this->sqlQuery->join(
        'mcapi_wallet__holder',
        'wallet_holder',
        'base_table.wid = wallet_holder.entity_id'
      );
      // This join would exclude wallets held by non-user Entities.
      $this->sqlQuery->join(
        'users_field_data',
        'u',
        'wallet_holder.holder_target_id = u.uid AND u.status = 1'
      );
    }
    return $this;
  }

}
