<?php

namespace Drupal\mcapi\Plugin\Validation\Constraint;

use Drupal\Core\Validation\Plugin\Validation\Constraint\UniqueFieldConstraint;

/**
 * Checks if a wallet name is unique on the site.
 *
 * @Constraint(
 *   id = "WalletNameUnique",
 *   label = @Translation("Wallet name unique", context = "Validation"),
 * )
 */
class WalletNameUnique extends UniqueFieldConstraint {

  public $message = "A wallet called '@name' already exists.";

  /**
   * {@inheritdoc}
   */
  public function validatedBy() {
    return '\Drupal\mcapi\Plugin\Validation\Constraint\WalletNameUniqueValidator';
  }

}
